/*************************************
 Compass 0.1.1
 (C) 2008 Hynek Sladky
 sladky@mujmail.cz
*************************************/

// ------------------------------------
// API
// ------------------------------------
#define ALLOW_ACCESS_TO_INTERNALS_OF_CONTROLS
#include <PalmOS.h>

#include <PmConnectorLib.h>
// ------------------------------------
// application headers
// ------------------------------------
#include "CompassR.h"
#include "version.h"
extern const char *build, *build_date, *build_time;
/******** ToDo ********/
/**********************
OPRAVY:
======

UPRAVY:
======
- umistit na WEB cely navod
  udelat nove stranky (pro kazdy projekt vlastni stranka)
  asi ty stranky udelat jen v anglictine (kvuli pristupu z ciziny)
  - ulozit vsechny mozne projekty, ktere stoji za to...
o pokud je jeden z rozmeru (asi sirka) nulovy, tak se udaj na LCD nezobrazuje...
- ikony pro Compass
- pri spusteni kontrolovat ruzne verze...
  projit si cely SW a podivat se, co vsechno je potreba kontrolovat
  - SrmSetWakeupHandler: New Serial Manager Feature Set version 1
  - ruzne notifikace
  - WinSetCoordinateSystem
  - treo funkce (Connector)
    je otazka, jak to je u T5 s rizenim napajeni???
    dle PDF to vypada, ze neumi zjistit class???

Hotovo:
=======
o povoleni behu na pozadi:
  - FtrPtrNew pro serial handler
  - FtrPtrNew pro globals
o zadani umisteni mista pro zobrazeni udaje
  mozna i vyber zarovnani (vlevo, vpravo, stred)
  - jen nevim, jak (kdy) budu z fieldu ukladat hodnoty
o CompassClose:
  smazat prostor pro tisk azimutu!
o udelat testovaci zapnuti primo v aplikaci
o zkontrolovat one-handed navigaci ve formulari!
o doplneni sirky,vysky oblasti pro zobrazovani
  aby bylo mozne tuto oblast mazat...
o enabled/disabled:
  - povoli notifikaci o spusteni aplikace
  - pripravi FtrPtrNew a MemPtrNew
o nevim proc se nedari spolehlive nastartovat kompas...
  asi budu muset analyzovat osciloskopem, co se na konektoru deje...
o mam v tom nejaky zmatek: musim si probrat vsechny mozne stavy a prechody a z toho navrhnout nejaky algoritmus...
o notifikace attach/detach?
  sysExternalConnectorAttachEvent
  sysExternalConnectorDetachEvent
o notifikace
  - spusteni aplikace:
    poznamenat si do globals a pokusit se spustit/vypnout kompas
  - pripojeni zarizeni:
    zobrazit okynko s informaci, ze probiha pripojovani kompasu
    zkontrolovat kompas, pripadne restarovat port
    pokud je spustena aplikace, aktivovat seriovy port
  - odpojeni zarizeni
    zavrit port    
o asi nejlepsi bude detekovat attach/detach
  musim si ale nekde poznamenat, ze pozadovana aplikace je/neni spustena...
  attach:
o on/off notifikace:
  - nenasel jsem (zatim?) zpusob, jak uplne vypnout port!
    vzdy zustane nejake zbytkove napeti na Rx/Tx dratech, ktere napaji procesor!
  - jedine, co asi bude uzitecne, je vypnout/zapnout mereni...
  x pokud je off a port bezi:
    Compass sleep:
    - vypnu port
    - vypnu napajeni
    - nastavim flag obnoveni
  x pokud je on a flag obnoveni:
    Compass resume:
    - zapnu napajeni
    - zapnu port
    - inicializuju kompas
o spusteni aplikace:
  - pokud je aplikace spravna a port jeste nebezi:
    - zapnu port
    - nastavim globalni promenne
    - nastavim serial handler
    ? povolim on/off notifikace
  - pokud je aplikace jina a port bezi:
    - vypnu port
    - nuluju promenne
    ? zakazu on/off notifikace
o Class codes:
  0FFF bez zarizeni
  000B pri spatne detekci (pokud zasunu konektor pri vypnutem Palmu)
  000F pri spatne detekci
  0003 pri dobre detekci
x pokud je zapnuty testovaci rezim, tak pri ukonceni aplikace se musi vypnout ???
  zkontrolovat, jak to vlastne funguje...
  - pri zmene aplikace se port automaticky zavre...
o otevru port
  zkusim detekci +INFO: pokud neni odezva, koncim! (zavreni portu...)
  - detekci zkusit vickrat...
    pak muzu vypustit SysTaskDelay pri notifikaci pripojeni konektoru
o pokud uz je spusteny CacheMate a teprve pak pripojim kompas, tak se nespusti...
  asi se nekontroluje ->run
o pokud neni nic pripojene, tak se pri spusteni CacheMate ceka moc dlouho!!!
  pri attach se provede reset portu,
  pri spusteni aplikace se nebude provadet reset portu...
o podpora kalibrace
  - prikaz +INIT : podivat se, jestli se nastavi nejake defaultni maximalni hodnoty...
  - prikaz +AZI=1
  - prikaz +CAL : asi by bylo vhodne, kdyby se i pri kalibraci mohlo neco zobrazovat...
  - prikaz +SAVE
  -> asi bude vyzadovat upravu FW kompasu: konec kalibrace se oznami nejakym textem...
o podpora znovuspusteni po resetu
o pri tisku si zkontrolovat HiRes rozliseni!!!
  obcas se udaj vytiskne do polovicni vzdalenosti!
o azimut se bude ukladat do Ftr pro pouziti v CacheNav_hacked...
  format bude double...
***********************/
// ------------------------------------
// defines
// ------------------------------------
#define AppID           'Cpas'
#define PREF_APP        0

#define FTR_GLOBALS     0
#define FTR_CN_LOW      10
#define FTR_CN_HIGH     11
#define FTR_HANDLER     99

#define ALLOW_RESET     0x4000
// ====================================
// global variables
// ------------------------------------
typedef struct {
  UInt32 port;
  FontID font;
  RectangleType box;
  Int16 justify;
  UInt16 flags;
} commonGlobalsType;

#define BUF_LEN 64
typedef struct {
  // copy from prefs
  commonGlobalsType com;
  // special globals
  UInt16 COM;
  LocalID appid;
  UInt16 wpos;
  Char buf[BUF_LEN+1];
  UInt8 run;
} globalsType;
globalsType *globals = NULL;
// ------------------------------------
// serial devices list
// ------------------------------------
UInt16 port_cnt = 0;
Char **port_name = NULL;
UInt32 *port_ID = NULL;
// ------------------------------------
// preferences
// ------------------------------------
#define FLG_ENABLED     0x0001
#define FLG_HIRES       0x0002
typedef struct {
  commonGlobalsType com;
  Char appl[dmDBNameLength];
} PrefType;
PrefType prefs = {
  {0, stdFont, {{140,0},{20,12}}, rightAlign},
  {0}
};
// ====================================
// DEBUG functions
// ------------------------------------
// UI debug window
// ------------------------------------
#include <stdarg.h>
void DEBUG (char *a, ...) {
char *b = MemPtrNew(256);
va_list p;
  va_start(p, a);
  StrVPrintF(b, a, p);
  FrmCustomAlert (show, b, "", "");
  va_end(p);
  MemPtrFree(b);
}
// ====================================
// seriova komunikace
// ------------------------------------
// handler pro seriovou komunikaci
// nesmim pouzivat primo konstantni retezce, protoze jsou ulozeny pred funkci!!! (viz AZI_str)
// ------------------------------------
//extern const Char AZI_str[];
Char *AZI_str (void);
void SerialHandler (UInt32 refcon) {
UInt8           *sbuf;
UInt32          len, pos;
UInt16          cos;
FlpCompDouble   az;

  if (SrmReceiveWindowOpen (((globalsType*)refcon)->COM, &sbuf, &len)!=errNone) return;
  // kopiruju si data do sveho bufferu
  for (pos=0; pos<len; pos++) {
    if (sbuf[pos]=='\r' || sbuf[pos]=='\n') {
      // zpracovani dat
      if (((globalsType*)refcon)->wpos>5) {
        FontID fnt;
        WinHandle win;
        UInt16 x, w;
        ((globalsType*)refcon)->buf[((globalsType*)refcon)->wpos]=0;
        if (!StrNCompare (((globalsType*)refcon)->buf, AZI_str (), 5)) {
          // ulozeni double hodnoty do Ftr
          //az.fd=FlpAToF (((globalsType*)refcon)->buf+5);
          FlpBufferAToF (&az.fd, ((globalsType*)refcon)->buf+5);
          FtrSet (AppID, FTR_CN_LOW, az.ul[0]);
          FtrSet (AppID, FTR_CN_HIGH, az.ul[1]);
          if (((globalsType*)refcon)->com.box.extent.x && ((globalsType*)refcon)->com.box.extent.y) {
            ((globalsType*)refcon)->wpos-=5;
            // nastaveni parametru pro vykreslovani
            win = WinGetDrawWindow ();
            WinSetDrawWindow (WinGetDisplayWindow ());
            fnt = FntSetFont (((globalsType*)refcon)->com.font);
            cos = kCoordinatesStandard;
            if (((globalsType*)refcon)->com.flags&FLG_HIRES) {
              cos = WinGetCoordinateSystem ();
              if (cos!=kCoordinatesStandard)
                WinSetCoordinateSystem (kCoordinatesStandard);
            }
            x=((globalsType*)refcon)->com.box.topLeft.x;
            w=FntCharsWidth (((globalsType*)refcon)->buf+5, ((globalsType*)refcon)->wpos);
            // vypocet polohy podle zarovnani
            if (((globalsType*)refcon)->com.justify==centerAlign) {
              x+=(((globalsType*)refcon)->com.box.extent.x>>1)-(w>>1);
            } else
            if (((globalsType*)refcon)->com.justify==rightAlign) {
              x+=((globalsType*)refcon)->com.box.extent.x-w;
            }
            // smazani oblasti a vykresleni aktualni hodnoty
            WinEraseRectangle (&((globalsType*)refcon)->com.box, 0);
            WinDrawChars (((globalsType*)refcon)->buf+5, ((globalsType*)refcon)->wpos, x, ((globalsType*)refcon)->com.box.topLeft.y);
            // navrat k puvodnimu nastaveni displeje
            if (cos!=kCoordinatesStandard)
              WinSetCoordinateSystem (cos);
            FntSetFont (fnt);
            WinSetDrawWindow (win);
          }
        }
        ((globalsType*)refcon)->wpos = 0;
      }
    } else 
    if (((globalsType*)refcon)->wpos<BUF_LEN) {
      ((globalsType*)refcon)->buf[((globalsType*)refcon)->wpos++]=sbuf[pos];
    }
  }
  SrmReceiveWindowClose (((globalsType*)refcon)->COM, pos);
  SrmPrimeWakeupHandler (((globalsType*)refcon)->COM, 1);
}
// ------------------------------------
// misto pro konstanty
// ------------------------------------
//static const Char AZI_str[]="*AZI:";
Char *AZI_str (void) {
  return "*AZI:";
}
// ------------------------------------
// jen adresa pro zjisteni delky handleru
// ------------------------------------
//#define SerialHandlerEnd        CheckDeviceClass
void SerialHandlerEnd (void) {
}
// ------------------------------------
// kontrola detekce serioveho zarizeni, pripadne restart portu
// ------------------------------------
Err CheckDeviceClass (UInt16 code, UInt32 port) {
UInt16 libref, i, j;
FormPtr frm;
  if (SysLibFind (kPmConnectorLibName, &libref)) {
    if (SysLibLoad (kPmConnectorLibType, kPmConnectorLibCreator, &libref)) {
      return 1;
    }
  }
  PmConnectorLibOpen (libref);
  PmConnectorLibControl (libref, kPmConnectorLibCtrlGetDeviceClass, (void*)&i);
  if ((code & ALLOW_RESET)) {
    code &= kPmConnectorClassMask;
    if (i!=code) {
      // reset portu
      frm = FrmNewForm (3000, "Serial Device", 40, 60, 80, 25, true, 0, 0, 0);
      FrmDrawForm (frm);
      FntSetFont (stdFont);
      WinDrawChars ("Port RESET", 10, 18, 13);
      // pokud se port otevre a zavre, tak se provede znovu detekce na class
      SrmOpen (port, 19200, &j);
      SrmSend (j, "+AZI=0\r", 7, &i);
      SrmSendWait (j);
      SrmClose (j);
      for (j=40; j; j--) {
        SysTaskDelay (10);
        PmConnectorLibControl (libref, kPmConnectorLibCtrlGetDeviceClass, (void*)&i);
        if (i==code) break;
      }
      FrmEraseForm (frm);
      FrmDeleteForm (frm);
    }
  }
  PmConnectorLibClose (libref);
  if (i!=code) return 2;
  return 0;
}
// ------------------------------------
// prijem a kontrola prijateho textu
// ------------------------------------
Err WaitCheckReply (UInt16 port, Char *str, UInt16 timeout) {
UInt32  size;
Char    buf;
Err     err;
UInt16  pos;

  pos = 0;
  while (str[pos]) {
    size=SrmReceive (port, &buf, 1, timeout, &err);
    if (err) return 1;
    if (!size) continue;
    if (str[pos]!=buf)
      pos=0;
    if (str[pos]==buf)
      pos++;
  }
  return 0;
}
// ------------------------------------
// otevreni a nastaveni portu
// ------------------------------------
UInt16 CompassOpen (UInt32 port) {
UInt16          portRef;
Err             err;
globalsType     *globals;
void            *func;
UInt16          i;

  portRef=0;
  if (FtrGet (AppID, FTR_GLOBALS, (UInt32*)&globals) || FtrGet (AppID, FTR_HANDLER, (UInt32*)&func))
    return 0;
  if (!globals || !func)
    return 0;
  // kontrola detekce serioveho zarizeni
  if (CheckDeviceClass (kPmConnectorClassGenericSerial, port)) return 0;
  // otevreni portu
  if (SrmOpen (port, 19200, &portRef)!=errNone)
    return 0;
  // kontrola pritomnosti kompasu
  for (i=4; i; i--) {
    SrmSend (portRef, "+INFO\r", 6, &err);
    err=WaitCheckReply (portRef, "*INFO:Compass", 5);
    SrmReceiveFlush (portRef, 5);
    if (!err) break;
  }
  if (!i) {
    SrmClose (portRef);
    return 0;
  }
  // zapnuti kompasu
  SrmSend (portRef, "+AZI=1\r", 7, &err);
  SrmSendWait (portRef);
  SrmReceiveFlush (portRef, 10);
  // zapnuti rezidentniho prijmu
  globals->COM=portRef;
  SrmSetWakeupHandler (portRef, func, (UInt32)globals);
  SrmPrimeWakeupHandler (portRef, 1);
  return portRef;
}
// ------------------------------------
// zavreni portu
// ------------------------------------
void CompassClose (globalsType *globals) {
Err     err;
  if (!globals) return;
  if (!globals->COM) return;
  // disable wakeup handler
  SrmSetWakeupHandler (globals->COM, NULL, 0);
  // stop sending azimuth
  SrmSend (globals->COM, "+AZI=0\r", 7, &err);
  SrmSendWait (globals->COM);
  // close port
  SrmClose (globals->COM);
  globals->COM = 0;
  // clear drawing region
  WinEraseRectangle (&globals->com.box, 0);
  // unregister Ftrs
  FtrUnregister (AppID, FTR_CN_LOW);
  FtrUnregister (AppID, FTR_CN_HIGH);
}
// ------------------------------------
// priprava pameti pro handler
// ------------------------------------
globalsType *CompassPrepare (PrefType *prefs) {
void            *func;
UInt32          size;
MemHandle       hndl;
globalsType     *globals=NULL;
UInt16          card;
LocalID         dbid;
  SysCurAppDatabase (&card, &dbid);
  // vytvoreni pameti pro globalni promenne
  if (!(hndl = MemHandleNew (sizeof (globalsType)))) return NULL;
  MemHandleSetOwner (hndl, 0);
  globals = MemHandleLock (hndl);
  FtrSet (AppID, FTR_GLOBALS, (UInt32)globals);
  // nastaveni struktury
  MemSet (globals, sizeof (globalsType), 0);
  MemMove (&globals->com, &prefs->com, sizeof (globals->com));
  globals->appid = DmFindDatabase (0, prefs->appl);
  if (globals->appid == dbid)
    globals->appid = 0;
  // vytvoreni pameti pro serial handler
  size=((UInt32)SerialHandlerEnd) + 2;
  size-=((UInt32)SerialHandler) + 2;
  if (!FtrPtrNew (AppID, FTR_HANDLER, size, &func)) {
    DmWrite (func, 0, (void*)&SerialHandler, size);
  }
  // prihlaseni notifikace
  SysNotifyRegister (card, dbid, sysNotifyAppLaunchingEvent, NULL, sysNotifyNormalPriority, globals);
  SysNotifyRegister (card, dbid, sysNotifySleepNotifyEvent, NULL, sysNotifyNormalPriority, globals);
  SysNotifyRegister (card, dbid, sysNotifyLateWakeupEvent, NULL, sysNotifyNormalPriority, globals);
  SysNotifyRegister (card, dbid, sysExternalConnectorAttachEvent, NULL, sysNotifyNormalPriority, globals);
  SysNotifyRegister (card, dbid, sysExternalConnectorDetachEvent, NULL, sysNotifyNormalPriority, globals);
  return globals;
}
// ------------------------------------
// uklizeni pameti handleru
// ------------------------------------
void CompassCleanup (globalsType *globals) {
void    *ptr;
UInt16          card;
LocalID         dbid;

  // ukonceni notifikace
  SysCurAppDatabase (&card, &dbid);
  SysNotifyUnregister (card, dbid, sysExternalConnectorDetachEvent, sysNotifyNormalPriority);
  SysNotifyUnregister (card, dbid, sysExternalConnectorAttachEvent, sysNotifyNormalPriority);
  SysNotifyUnregister (card, dbid, sysNotifyLateWakeupEvent, sysNotifyNormalPriority);
  SysNotifyUnregister (card, dbid, sysNotifySleepNotifyEvent, sysNotifyNormalPriority);
  SysNotifyUnregister (card, dbid, sysNotifyAppLaunchingEvent, sysNotifyNormalPriority);
  // uvolneni pameti
  if (!FtrGet (AppID, FTR_GLOBALS, (UInt32*)&ptr)) {
    if (ptr) {
      MemHandleFree (MemPtrRecoverHandle (ptr));
    }
    FtrUnregister (AppID, FTR_GLOBALS);
  }
  FtrPtrFree (AppID, FTR_HANDLER);
}
// ------------------------------------
// kalibrace kompasu
// ------------------------------------
/**
UInt16 CountBits (UInt32 value) {
UInt16 cnt;
  cnt=0;
  while (value) {
    if (value&1) cnt++;
    value>>=1;
  }
  return cnt;
}
**/
Boolean progressBar (PrgCallbackDataPtr ptr) {
  if (ptr->message && *ptr->message) {
    StrPrintF (ptr->textP, "%s", ptr->message);
  } else {
    StrPrintF (ptr->textP, "%d%%", ptr->stage);
  }
  return true;
}
Err CompassCalib (globalsType *globals) {
Err             err;
ProgressPtr     pbd;
Char            buf[16];
UInt16          pos;
EventType       event;
UInt32          size;
  // otevreni portu
  if (!globals) return 1;
  if (!globals->COM)
    CompassOpen (globals->com.port);
  if (!globals->COM) return 1;
  // progress dialog
  pbd=PrgStartDialog ("Compass calibration", progressBar, NULL);
  PrgUpdateDialog (pbd, 0, 0, "Initialization", true);
  // zruseni rezidentniho prijmu
  SrmSetWakeupHandler (globals->COM, NULL, 0);
  // inicializace kompasu
  // vypnuti posilani informaci
  SrmSend (globals->COM, "+AZI=0\r", 7, &err);
  SrmReceiveFlush (globals->COM, 5);
  // inicializace do defaultnich hodnot
  SrmSend (globals->COM, "+INIT\r", 6, &err);
  WaitCheckReply (globals->COM, "*INIT:done.", 5);
  // zapnuti posilani informaci
  SrmSend (globals->COM, "+AZI=1\r", 7, &err);
  WaitCheckReply (globals->COM, "*AZI:", 75);
  // start kalibrace
  SrmSend (globals->COM, "+CAL\r", 5, &err);
  WaitCheckReply (globals->COM, "*CAL:turn", 15);
  // prijimani odezvy a zpracovani informace o vysledku
  do {
    // cekani na kalibracni zpravu
    err = WaitCheckReply (globals->COM, "*CAL:", 75);
    if (err) break;
    // prijem kalibracni zpravy
    pos=0;
    do {
      size=SrmReceive (globals->COM, &buf[pos], 1, 5, &err);
      if (err) break;
      if (size) {
        if (buf[pos]=='\r' || buf[pos]=='\n') break;
        if (pos<14) pos++;
      }
    } while (1);
    if (err) break;
    buf[pos]=0;
    if (StrStr (buf, "done.")) break;
    if (buf[0]>='0' && buf[0]<='9') {
      //PrgUpdateDialog (pbd, 0, (100*CountBits (StrAToI (buf)))/4, NULL, true);
      PrgUpdateDialog (pbd, 0, (100*StrAToI (buf))/6, NULL, true);
    }
    // Cancel v Progress dialogu funguje jen kdyz se zpracovavaji eventy...
    EvtResetAutoOffTimer ();
    EvtGetEvent (&event, 0);
    if (!SysHandleEvent (&event))
      if (!FrmDispatchEvent (&event))
        PrgHandleEvent (pbd, &event);
    if (PrgUserCancel (pbd)) {
      err=1;
      break;
    }
  } while (1);
  // vypnuti posilani informaci
  SrmSend (globals->COM, "+AZI=0\r", 7, &err);
  SrmSendWait (globals->COM);
  SrmReceiveFlush (globals->COM, 5);
  if (!err) {
    // ulozeni do EEPROM
    SrmSend (globals->COM, "+SAVE\r", 6, &err);
    WaitCheckReply (globals->COM, "*SAVE:done.", 25);
  }
  // uvolneni bufferu
  SrmReceiveFlush (globals->COM, 5);
  // zavreni portu
  CompassClose (globals);
  // zavreni progress dialogu
  PrgStopDialog (pbd, true);

  return 0;
}


// ====================================
// notification handler
// ------------------------------------
Err NotifyProc (SysNotifyParamType *notify) {
globalsType     *globals;
UInt16          i;
  globals = (globalsType*)notify->userDataP;
  // spusteni aplikace
  if (notify->notifyType == sysNotifyAppLaunchingEvent) {
    if (((SysNotifyAppLaunchOrQuitType*)notify->notifyDetailsP)->dbID == globals->appid) {
      globals->run = 1;
      if (!globals->COM)
        CompassOpen (globals->com.port);
    } else {
      globals->run = 0;
      if (globals->COM) {
        CompassClose (globals);
      }
    }
    return 0;
  }
  // pripojeni konektoru
  if (notify->notifyType == sysExternalConnectorAttachEvent) {
    // kontrola class
    if (!CheckDeviceClass (kPmConnectorClassGenericSerial | ALLOW_RESET, globals->com.port)) {
      if (globals->run) {
        //SysTaskDelay (50);
        CompassOpen (globals->com.port);
      }
    }
    return 0;
  }
  // odpojeni konektoru
  if (notify->notifyType == sysExternalConnectorDetachEvent) {
    if (globals->COM)
      CompassClose (globals);
    return 0;
  }
  // zapnuti Palma
  if (notify->notifyType == sysNotifyLateWakeupEvent) {
    if (globals->COM)
      SrmSend (globals->COM, "+AZI=1\r", 7, &i);
    return 0;
  }
  // vypnuti Palma
  if (notify->notifyType == sysNotifySleepNotifyEvent) {
    if (globals->COM) {
      SrmSend (globals->COM, "+AZI=0\r", 7, &i);
      SrmSendWait (globals->COM);
    }
    return 0;
  }
  return 0;
}
// ====================================
// application selection
// ------------------------------------
Int16 SelectApp (UInt16 list_id, Char *name) {
UInt16          i, cnt;
MemHandle       hndl;
Char            **lstr;
SysDBListItemType *dblist;
void            *tptr;
FormPtr         frm;

  // spocitani aplikaci + vytvoreni seznamu aplikaci
  if (!SysCreateDataBaseList ('appl', 0, &cnt, &hndl, false))
    return 1;
  i=noListSelection;
  if (cnt && hndl) {
    // pamet pro ukazatele
    lstr=MemPtrNew (cnt * sizeof (Char*));
    if (lstr) {
      dblist=MemHandleLock (hndl);
      for (i=0; i<cnt; i++) lstr[i]=dblist[i].name;
      frm=FrmGetActiveForm ();
      LstSetListChoices (tptr=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_id)), lstr, cnt);
      // hledani jmena
      if (*name)
        for (i=0; i<cnt; i++)
          if (!StrCompare (name, dblist[i].name)) {
            LstSetTopItem (tptr, i);
            break;
          }
      LstSetSelection (tptr, (i<cnt)?i:noListSelection);
      // vyber aplikace
      i=LstPopupList (tptr);
      if (i!=(UInt16)-1)
        StrCopy (name, lstr[i]);
      // uvolneni zaznamu/pameti
      LstSetListChoices (tptr, NULL, 0);
      MemPtrFree (lstr);
      MemHandleUnlock (hndl);
    }
  }
  if (hndl) MemHandleFree (hndl);
  return (i!=(UInt16)-1)?0:-1;
}
// ====================================
// main form handler
// ------------------------------------
static Boolean MainFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;
void            *tptr;
UInt16          i;
Char            str[12];
MemHandle       hndl;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      // hledani odpovidajiciho nazvu
      LstSetListChoices (tptr=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, port_list)), port_name, port_cnt);
      for (i=0; i<port_cnt; i++) {
        if (prefs.com.port==port_ID[i]) {
          CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, port_trig)), port_name[i]);
          LstSetTopItem (tptr, i);
          break;
        }
      }
      LstSetSelection (tptr, (i<port_cnt)?i:noListSelection);
      // nastaveni aplikace
      if (*prefs.appl) CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, appl_trig)), prefs.appl);
      // nastaveni soucasneho stavu
      if (globals)
        CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, chk_enabled)), 1);
      StrPrintF (str, "%d,%d", prefs.com.box.topLeft.x, prefs.com.box.topLeft.y);
      FldInsert (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, position_fld)), str, StrLen (str));
      StrPrintF (str, "%d,%d", prefs.com.box.extent.x, prefs.com.box.extent.y);
      FldInsert (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, size_fld)), str, StrLen (str));
      tptr=LstGetSelectionText (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, position_list)), prefs.com.justify);
      if (tptr) CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, position_trig)), tptr);
      ((ControlType*)FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, font_select)))->font=prefs.com.font;
    case frmUpdateEvent:
      FrmDrawForm (frm);
      break;
    case frmCloseEvent:
      hndl = FldGetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, position_fld)));
      if (hndl) {
        StrCopy (str, MemHandleLock (hndl));
        MemHandleUnlock (hndl);
        i=0;
        while (str[i] && (str[i]<'0' || str[i]>'9')) i++;
        if (str[i]>='0' && str[i]<='9') prefs.com.box.topLeft.x=StrAToI (&str[i]);
        while (str[i]>='0' && str[i]<='9') i++;
        while (str[i] && (str[i]<'0' || str[i]>'9')) i++;
        if (str[i]>='0' && str[i]<='9') prefs.com.box.topLeft.y=StrAToI (&str[i]);
      }
      hndl = FldGetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, size_fld)));
      if (hndl) {
        StrCopy (str, MemHandleLock (hndl));
        MemHandleUnlock (hndl);
        i=0;
        while (str[i] && (str[i]<'0' || str[i]>'9')) i++;
        if (str[i]>='0' && str[i]<='9') prefs.com.box.extent.x=StrAToI (&str[i]);
        while (str[i]>='0' && str[i]<='9') i++;
        while (str[i] && (str[i]<'0' || str[i]>'9')) i++;
        if (str[i]>='0' && str[i]<='9') prefs.com.box.extent.y=StrAToI (&str[i]);
      }
      break;
/**
    case winExitEvent: // tracking of menu and other windows creation
      if (event->data.winExit.exitWindow==(WinHandle)FrmGetFormPtr (main_form)) drawEnable=0;
      break;
    case winEnterEvent: // tracking of menu and other windows creation
      if (event->data.winEnter.enterWindow==(WinHandle)FrmGetFormPtr (main_form) && event->data.winEnter.enterWindow==(WinHandle)FrmGetFirstForm ()) {
        drawEnable=true;
      }
      break;
**/
    case menuEvent:
      handled=true;
      MenuEraseStatus (NULL);
      switch (event->data.menu.itemID) {
        case menu_about:
          if (!FrmCustomAlert (alert_about, build, build_date, build_time)) break;
        case menu_help:
          FrmHelp (str_about);
          break;
        case menu_test:
          if (!globals) break;
          if (globals->COM) {
            CompassClose (globals);
          } else {
            // kontrola device class
            //if (!CheckDeviceClass (kPmConnectorClassGenericSerial)) break;
            CheckDeviceClass (kPmConnectorClassGenericSerial | ALLOW_RESET, globals->com.port);
            // otevreni portu
            if (!CompassOpen (globals->com.port))
              DEBUG ("Error opening port!");
          }
          break;
        case menu_calib:
          CompassCalib (globals);
          break;
	default:
	  handled=false;
	  break;
      }
      break;
/*
    case keyDownEvent:
      switch (event->data.keyDown.chr) {
	default:
	  break;
      }
      break;
*/
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
        case chk_enabled:
          if (CtlGetValue (event->data.ctlSelect.pControl)) {
            globals = CompassPrepare (&prefs);
            if (!globals) handled=true;
            prefs.com.flags|=FLG_ENABLED;
          } else {
            CompassCleanup (globals);
            prefs.com.flags&=~FLG_ENABLED;
          }
          break;
#ifdef chk_test
        case chk_test:
          if (!globals) break;
          if (CtlGetValue (event->data.ctlSelect.pControl)) {
            if (!globals->COM) {
              // kontrola device class
              //if (!CheckDeviceClass (kPmConnectorClassGenericSerial)) break;
              CheckDeviceClass (kPmConnectorClassGenericSerial | ALLOW_RESET, globals->com.port);
              // otevreni portu
              CompassOpen (globals->com.port);
            }
          } else {
            if (globals->COM) {
              CompassClose (globals);
            }
          }
          break;
#endif
        case appl_trig:
          if (!SelectApp (program_list, prefs.appl)) {
            CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, event->data.ctlSelect.controlID)), prefs.appl);
          }
          handled = true;
          break;
        case font_select:
          prefs.com.font = FontSelect (prefs.com.font);
          if (event->data.ctlSelect.pControl->font!=prefs.com.font) {
            event->data.ctlSelect.pControl->font=prefs.com.font;
            CtlDrawControl (event->data.ctlSelect.pControl);
          }
          break;
	default:
	  break;
      }
      break;
    case popSelectEvent:
      switch (event->data.popSelect.listID) {
        case port_list:
          prefs.com.port=port_ID[event->data.popSelect.selection];
          break;
        case position_list:
          prefs.com.justify=event->data.popSelect.selection;
          break;
        default:
          break;
      }
      break;
    default:
      break;
  }
  return handled;
}
// ====================================
// basic application functions
// ------------------------------------    
// startup setup
// ------------------------------------
static Char *StartApplication(void) {
UInt16          i;
DeviceInfoType  info;
UInt32          ver;

  // initializing variables
  if (FtrGet (AppID, FTR_GLOBALS, (UInt32*)&globals))
    globals = NULL;

  // loading preferences
  i=0;
  if (PrefGetAppPreferences (AppID, PREF_APP, NULL, &i, true)!=noPreferenceFound) {
    if (i > sizeof (prefs)) i=sizeof (prefs);
    PrefGetAppPreferences (AppID, PREF_APP, &prefs, &i, true);
  }

  // checking required versions
  // New Serial Manager
  i = FtrGet (sysFileCSerialMgr, sysFtrNewSerialPresent, &ver);
  if (i || !ver) return "Serial Manager version";
  // OS version
  i = FtrGet (sysFtrCreator, sysFtrNumROMVersion, &ver);
  //if (i || ver<0x04003000) return 1;
  // v poznamce je, ze 4.1 and earlier ty notifikace neposilaji
  // ale ze jsou poprve v SDK 4.0 Update 1
  // takze nevim, co mam pouzit...
  if (i || ver<=0x04013000) return "PalmOS version";
  // High-Density Display
  i = FtrGet (sysFtrCreator, sysFtrNumWinVersion, &ver);
  if (!i && ver>=4) prefs.com.flags |= FLG_HIRES;
  else prefs.com.flags &= ~FLG_HIRES;
  // Connector library


  // load serial port names
  SrmGetDeviceCount (&port_cnt);
  for (i=0; i<port_cnt; i++) {
    SrmGetDeviceInfo (i, &info);
  }
  port_name = MemPtrNew (port_cnt * sizeof (Char*));
  if (port_name == NULL) return "Memory Allocation";
  port_ID = MemPtrNew (port_cnt * sizeof (UInt32));
  if (port_ID == NULL) return "Memory Allocation";
  for (i=0; i<port_cnt; i++) {
    SrmGetDeviceInfo (i, &info);
    port_name[i]=info.serDevPortInfoStr;
    port_ID[i]=info.serDevCreator;
  }
  return NULL;
}
// ------------------------------------
// exit cleanup
// ------------------------------------
static void StopApplication (void) {

  // saving preferences
  PrefSetAppPreferences (AppID, PREF_APP, 0, &prefs, sizeof (prefs), true);
  // freeing memory
  if (port_ID!=NULL) MemPtrFree (port_ID);
  if (port_name!=NULL) MemPtrFree (port_name);
}
// ------------------------------------
// event loop
// ------------------------------------
static void EventLoop(void) {
FormPtr         form;
EventType       event;
UInt16          err;

  do {
    EvtGetEvent (&event, evtWaitForever);
    if (SysHandleEvent (&event)) continue;
    if (MenuHandleEvent (NULL, &event, &err)) continue;
    if (event.eType == frmLoadEvent) {
      FrmSetActiveForm (form=FrmInitForm (event.data.frmLoad.formID));
      switch (event.data.frmLoad.formID) {
	case main_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) MainFormHandler);
	  break;
      }
    }
    if (FrmDispatchEvent (&event)) continue;
  } while (event.eType != appStopEvent);
  FrmCloseAllForms ();
}
// ------------------------------------
// application entry point
// ------------------------------------
UInt32  PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
Char *estr;

  // notification function
  if (cmd==sysAppLaunchCmdNotify) {
    return NotifyProc ((SysNotifyParamType*)cmdPBP);
  }
  // reset auto-activation
  if (cmd==sysAppLaunchCmdSystemReset) {
    PrefType lpref;
    UInt16 size=0;
    if (PrefGetAppPreferences (AppID, 0, NULL, &size, true)!=noPreferenceFound) {
      if (size >sizeof (lpref)) size=sizeof (lpref);
      PrefGetAppPreferences (AppID, 0, &lpref, &size, true);
      if (lpref.com.flags & FLG_ENABLED)
        CompassPrepare (&lpref);
    }
    return 0;
  }
  if (cmd!=sysAppLaunchCmdNormalLaunch)
    return 0;
  // application start-up part
  estr=StartApplication ();
  if (estr) {
    FrmCustomAlert (cantRunApp, estr, "", "");
    StopApplication ();
    return 1;
  }
  // display main form
  FrmGotoForm (main_form);
  // event loop
  EventLoop ();
  // application end routine
  StopApplication ();
  return 0;
}
